package com.sun.net.httpserver;

import java.net.InetSocketAddress;
import java.io.IOException;
import java.io.OutputStream;
import java.io.InputStream;
import java.net.URI;
import jdk.Exported;

@Exported
public abstract class HttpExchange
{
    protected HttpExchange() {
    }
    
    public abstract Headers getRequestHeaders();
    
    public abstract Headers getResponseHeaders();
    
    public abstract URI getRequestURI();
    
    public abstract String getRequestMethod();
    
    public abstract HttpContext getHttpContext();
    
    public abstract void close();
    
    public abstract InputStream getRequestBody();
    
    public abstract OutputStream getResponseBody();
    
    public abstract void sendResponseHeaders(int p0, long p1) throws IOException;
    
    public abstract InetSocketAddress getRemoteAddress();
    
    public abstract int getResponseCode();
    
    public abstract InetSocketAddress getLocalAddress();
    
    public abstract String getProtocol();
    
    public abstract Object getAttribute(String p0);
    
    public abstract void setAttribute(String p0, Object p1);
    
    public abstract void setStreams(InputStream p0, OutputStream p1);
    
    public abstract HttpPrincipal getPrincipal();
}
